#import "NetTalk.h"
#import <objc/Object.h>
#import "TalkRequest.h"
#import <appkit/Window.h>
#import <bsd/sys/param.h>


@class List, View;


@interface NetTalkThinker : Object
{
/* Info.nib objects */
	id         versionField;

/* the NetTalkClient object */
	id	       client;

/* for animation display */
	id         appTile;
	id         appIconContentView;
	id         imageList;
	DPSTimedEntry	timedEntry;

/* nib panels */
	id	       infoPanel;
	id	       prefPanel;
	id         openTalkPanel;
	id	       requestPanel;

/* connections to menu */
	id         windowsSubmenuCell;
	id         stayAboveCell;
	id         winCloseCell;
	id         connectionSubmenuCell;
	id         conncloseCell;

/* connections to Request.nib */
	id         refuseButton;
	id         insertButton;
	id         connectButton;
	id         requestBrowser;
	id         topicText;
	
/* bundle stuff */
	List      *bundleList;
	Class      currentControllerClass;

/* other objects */
	List      *requestList;
	id         mailSpeaker;
}

/* mail connection */
- sendComments:sender;

/* menu enabling/disabling */
- (BOOL)closeActive:menuCell;
- (BOOL)stayAboveActive:menuCell;

- client;

/* action methods */
- showInfoPanel:sender;
- showPrefPanel:sender;
- showRequestPanel:sender;
- setRequest:sender;
- openTalk:sender;

@end

@interface NetTalkThinker(IconAnimation)

- _display:image;
- removeTimedEntry;
- newRequest:sender;
- newClient:sender;

@end

@interface NetTalkThinker(Connecting)

- connect:sender;
- insert:sender;
- refuse:sender;
- (Window *) connectionFor:(const char *)aClientUName
		andCode:(const char *)aCode;
- (Window *) connectionForTopic:(const char *)aTopic;
- (TalkRequest *)requestFromUName:(const char *)uName
	forCode:(const char *)aCode;
- (const char *) realNameFor:(const char *)aClientUName;

@end

@interface NetTalkThinker(OpenTalkDelegate)

/* being the OpenTalk delegate */
- (int)getClientCount;
- (int)getClientName:(char*)aClientName at:(int)pos;
- (int)getUniqueName:(char*)aUniqueName at:(int)pos;

@end

@interface NetTalkThinker(BundleLoading)

- initializeBundles:sender;
- (Class)controllerClassFor:(const char *)className;

@end
